Description

Fluid should provide a Switch VH that behaves like the well-known switch-case structure.

Syntax suggestion:

<f:switch comparand="{foo.bar}">
<f:switch.case comparand="valuecase1">
<span>Output in this case.</span>
</f:switch.case>

<f:switch.case comparand="nothervaluecase">
<a>Output in another case.</a>
</f:switch.case>

<f:switch.case comparand="third">
<a>Output in another case.</a>
</f:switch.case>

<f:switch.default>
Default value if nothing else matches.
</f:switch.default>
</f:switch>

There's an already present implementation here: http://fedext.net/fed-viewhelpers/loops-conditions/switch/ but tbh | at least don't agree

with the "default" implementation because it could collide with the value being "default" as string:

<fed:switch value="{switchValue}">

<fed:case case="1">
<p>Case was 1</p>
</fed:case>
<fed:case case="default">
<p>Case was default</p>

</fed:case>

</fed:switch>

Associated revisions

Revision 4fd6714d - 2013-05-29 13:33 - Bastian Waidelich
http://fedext.net/fed-viewhelpers/loops-conditions/switch/

[FEATURE] Switch View Helper

Simple view helper that allows you to render content depending
on a given value or expression.

It bahaves similar to a basic switch statement in PHP.

Usage:

<f:switch expression="{person.gender}">
<f:case case="male">Mr.</f:case>
<f:case case="female">Mrs.</f:case>

</f:switch>

Change-Id: Ibec7b1acc4555a8f69ea7465023a2cf2b06e63aa
Resolves: #33817

Releases: master

Revision 88edf89e - 2013-06-05 10:49 - Wouter Wolters

[BUGFIX] Typo in SwitchViewHelper code example

Fixes a typo in the usage example introduced with
Ibec7b1acc4555a8f69ea7465023a2cf2b06e63aa

Change-Id: Icc23272ed72948a79a09b9b660ac8ed6cca360ac
Fixes: #48856

Related: #33817

Releases: master

History

#1 - 2012-02-09 15:31 - Adrian Foder

additionally, | would prefer dropping "break" support because its use is also pretty ugly in "real" situations imho.

#2 - 2012-02-09 15:48 - Bastian Waidelich
- Status changed from New to Accepted
- Assigned To set to Bastian Waidelich

Hi, that's already on my (longish) todo list. | agree with your two points on the magic "default" and break.

#3 - 2012-04-03 16:20 - Bastian Waidelich
- File SwitchViewHelper.php added
- File CaseViewHelper.php added

Attached a first version that works in general but has side effects when used nested - so it still needs some adjustments
#4 - 2013-05-15 13:29 - Gerrit Code Review

- Status changed from Accepted to Under Review

Patch set 1 for branch master has been pushed to the review server.
It is available at https://review.typo3.org/20787

#5 - 2013-05-29 13:33 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at https://review.typo3.0rg/20787

#6 - 2013-05-29 14:36 - Bastian Waidelich
- Status changed from Under Review to Resolved

- % Done changed from 0 to 100

Applied in changeset commit:4fd6714dd228e34fe2603dd1920ea2684c602eef.

Files

SwitchViewHelper.php 2.7kB 2012-04-03 Bastian Waidelich

CaseViewHelper.php 1.5kB 2012-04-03 Bastian Waidelich
